
function love.load()
	math.randomseed(os.time())
	--VARIABLES
	size = 20 
	gx = math.random(150, 750 - size)
	gy = math.random(150, 400 - size)
	gx2 = math.random(150, 750 - size)
	gy2 = math.random(150, 400 - size)
	score = 0
	sound = true
	paused = false
	itimeleft = 15 
	timeleft = itimeleft
	timeup = false
	bonus = 0	
	gamestarted = false
	bdotr = 0
	
	--IMAGES
	sb = love.graphics.newImage("image/soundb.png")
	sbm = love.graphics.newImage("image/soundbm.png")
	vig = love.graphics.newImage("image/vig.png")
	dot = love.graphics.newImage("image/dot.png")
	shadow = love.graphics.newImage("image/soundbs.png")
	pmenu = love.graphics.newImage("image/pause.png")
	sidebar = love.graphics.newImage("image/sidebar.png")
	resetb = love.graphics.newImage("image/resetb.png")
	splash = love.graphics.newImage("image/splash.png")
	bdot = love.graphics.newImage("image/bdot.png")
	star = love.graphics.newImage("image/star.png")
	
	
	--MISC SHIT
	font = love.graphics.newFont(18)
	love.graphics.setFont(font)
	love.graphics.setBackgroundColor(math.random(0,150), math.random(0,150) ,math.random(0,150))
	pop = love.audio.newSource("sound/pop.ogg", "static")
	pop:setVolume(0.5)
	
	--Particle Systems
	
	--Mouse Particles
	love.graphics.setColorMode("modulate")
	part = love.graphics.newImage("image/part.png")
	p = love.graphics.newParticleSystem(part, 100000)
	p:setEmissionRate(10)
	p:setParticleLife(5)
	p:setPosition(love.mouse.getX(), love.mouse.getY())
	p:setSize(0.5)
	p:setSizeVariation(1)
	p:setSpread(10)
	p:setSpeed(10)
	p:setColor(0,0,0,50,0,0,0,0)
	
	--Explosion debree
	part2 = love.graphics.newImage("image/part2.png")
	p2 = love.graphics.newParticleSystem(part, 100000)
	p2:setEmissionRate(1000)
	p2:setParticleLife(4)
	p2:setPosition(love.mouse.getX(), love.mouse.getY())
	p2:setSize(0.1)
	p2:setSizeVariation(1.5)
	p2:setTangentialAcceleration(50,100)	
	p2:setSpread(10)
	p2:setSpeed(60)
	p2:setColor(100,100,100,100,0,0,0,0)
	p2:setLifetime(0.15)
	p2:setGravity(-10,10)
	p2:stop()
	
	--Explosion smokey
	p3 = love.graphics.newParticleSystem(part2, 100000)
	p3:setEmissionRate(1000)
	p3:setParticleLife(4)
	p3:setPosition(love.mouse.getX(), love.mouse.getY())
	p3:setSize(0.5)
	p3:setSizeVariation(1)
	p3:setTangentialAcceleration(10,10)	
	p3:setSpread(10)
	p3:setSpeed(60)
	p3:setColor(60,60,60,60,0,0,0,0)
	p3:setLifetime(0.2)
	p3:stop()
	
	love.graphics.setBlendMode("alpha")
end

function love.update(dt)
if gamestarted == true then
	--timer
	if paused == false then
		timeleft = timeleft - dt
	end
	if timeleft <= 0 then
		timeup = true
		paused = true
		timeleft = 0
	end
	--useless particle boost
	if love.mouse.isDown("l") then
		p:setEmissionRate(50)
		else
		p:setEmissionRate(5)
	end
	--OTHER SHIT
	if paused == false then
		bdotr = bdotr + dt
		p2:update(dt)
		p3:update(dt)
		p:update(dt)
		p:setPosition(love.mouse.getX() , love.mouse.getY())
	if love.mouse.getX() > gx and love.mouse.getX() < gx + size and love.mouse.getY() > gy and love.mouse.getY() < gy + size then
		p2:setPosition(gx + 10 , gy+ 10)
		p3:setPosition(gx + 10 , gy+ 10)
		p2:start()
		p3:start()
		--"Pop" sound
		if sound == true then
		i = math.random(0,2)
			if i == 0 then
				pop:setPitch(0.9)
				love.audio.play(pop)
			elseif i == 1 then
				pop:setPitch(1.1)
				love.audio.play(pop)
			elseif i == 2 then
				pop:setPitch(1.0)
				love.audio.play(pop)
			end
		end
		love.graphics.setBackgroundColor(math.random(0, 150), math.random(0, 150), math.random(0, 150))
		if bonus >= 0 and bonus <= 4 then
			score = score + 1
		elseif bonus == 5 then -- star
			score = score + 5
			timeleft = timeleft + 5
		elseif bonus >= 6 and bonus <= 14 then
			score = score + 1
		elseif bonus == 15 then -- gold star
			score = score * 2
			timeleft = timeleft + 15
		end
		bonus = math.random(0,15)
		gx = math.random(150, 750 - size)
		gy = math.random(150, 400 - size)
		end
	else
		p2:stop()
		p3:stop()
	end
end
end

function love.draw()
	if gamestarted == true then
		love.graphics.setBlendMode("additive")
		love.graphics.draw(p2)
		love.graphics.draw(p3)
		love.graphics.setBlendMode("alpha")
		love.graphics.draw(p)
		love.graphics.setColor(255,255,255)
		love.graphics.draw(vig, 150, 0)
		love.graphics.draw(sidebar)
		love.graphics.draw(shadow, -12, 400-65)
		love.graphics.setColor(180,180,180)
		love.graphics.print("Score: "..score, 3, 0)
		love.graphics.setColor(255,255,255)
		love.graphics.print("Time left: "..math.floor(timeleft), 3, 20)
		--love.graphics.print("Particles: "..p:count() + p2:count(), 3, 26 + 10, 0,  0.8, 0.8)
		--love.graphics.print("FPS: "..love.timer.getFPS(), 3, 40+10, 0, 0.8, 0.8)	
		love.graphics.setColor(100, 100, 100)
		love.graphics.print("v3p", 712, 400-23)
		love.graphics.setColor(255,255,255)
		--Bonus dot/star
		if bonus >= 0 and bonus <= 4 then
			love.graphics.draw(dot, gx, gy)
		elseif bonus == 5 then
			love.graphics.draw(star, gx+5, gy+5, bdotr, 1, 1, 10, 10)
		elseif bonus >= 6 and bonus <= 14 then
			love.graphics.draw(dot, gx, gy)
		elseif bonus == 15 then
			love.graphics.draw(bdot, gx+5, gy+5, bdotr, 1, 1, 10, 10)
		end
		--Mute button
		if sound == true then
			love.graphics.draw(sb, 8, 400- 45)
		elseif sound == false then
		love.graphics.draw(sbm, 8,400-45)
		end
		--If paused/gameover
		if paused == true then
			if timeup == false then
				love.graphics.draw(pmenu, 0, 0)
				love.graphics.draw(resetb, 8, 313)
				love.graphics.print("Paused", 600/2, 150)
			elseif timeup ==true then
				love.graphics.draw(pmenu, 0, 0)
				love.graphics.setColor(200,0,0)
				love.graphics.print("Game Over!", 600/2,150) 
				love.graphics.setColor(255,255,255)
				love.graphics.print("You scored: "..score, 600/2, 190, 0, 0.9, 0.9)
				love.graphics.draw(resetb, 8 , 313)
			end
		end
	else
	love.graphics.draw(splash)
	end
end

function love.mousepressed(x, y, button)
	if button == "l" then
		if gamestarted == true then
			--Reset button
			if love.mouse.getX() > 8  and love.mouse.getX() < 88  and love.mouse.getY() > 313 and love.mouse.getY() < 313 + 40 then
					if paused == true then
						if timeup == false then
							score = 0
							timeleft = itimeleft
							paused = false
						elseif timeup == true then
							score = 0
							timeleft = itimeleft
							gx = math.random(150, 750 - size)
							gy = math.random(150, 400 - size)
							paused = false
							timeup = false
							p:reset()
							p2:reset()
							p3:reset()
						end
					end
				end
				--Mute Button
			if love.mouse.getX() > 8 - 45 and love.mouse.getX() < 8 + 45 and love.mouse.getY() > 400-45 and love.mouse.getY() < 400-45 + 40  then
				if sound == true then
					sound = false
				elseif sound == false then
					sound = true
				end
			end
		else
		--Splash
			gamestarted = true
		end
	end
end


function love.keypressed(key)
	if key == "p" then
		if paused == false then
			paused = true
		elseif paused == true then
			paused = false
		end
	end
end
